require 'spec_helper'

describe GremienController, :type => :controller  do
  let(:valid_update_attributes) { {"name"=>"NeuesGremium"}  }
  #  let(:valid_session) { {locale: :de} }

  def self.create_gremium
    before(:each) do
      @gremium = FactoryGirl.create(:gremium)    
    end
  end
#  def self.create_active_gremium
#    before(:each) do
#      @gremium = FactoryGirl.create(:gremium, active: true)    
#    end
#  end

  let(:object_variable) {:gremium}    
  let(:assigned_object_variable) {@gremium}
  let(:object_class) {Gremium}

  describe "GET index" do
    create_gremium
    subject(:action) {  get :index, {} }
    let(:object_variable) {:gremien}    
    let(:assigned_object_variable) {[@gremium]}
    it_behaves_like "it is success"
    it_behaves_like "it assigns object"  
  end

  describe "GET show" do
    create_gremium
    subject(:action) { get :show, {:id => @gremium.to_param}}
    it_behaves_like "it is success"
    it_behaves_like "it assigns object"
      it "renders the 'show' template" do
        expect(action).to render_template("show")
      end
      it "assigns memberships" do
        action
        expect(assigns(:memberships)).to be_a(ActiveRecord::Relation)
      end

  end

  describe "GET new" do
    subject(:action) { get :new, {}}
    describe "with fetuser" do
      login_fet_user
      it_behaves_like "it assigns new object"
      it_behaves_like "it is success"  
    end
    describe "without user" do 
      logout_user
      it_behaves_like "it is restricted"
    end 

  end

  describe "GET edit" do

    subject(:action) {get :edit, :id=>@gremium.to_param}
    login_fet_user
    create_gremium
    it_behaves_like "it is success"
    it_behaves_like "it assigns object"
      it "assigns memberships" do
        action
        expect(assigns(:memberships)).to be_a(ActiveRecord::Relation)
      end

    it "assigns the requested gremium as @gremium" do
      expect{action}.to change {assigns(:gremium)}.to(@gremium)
 #     expect(assigns(:gremium)).to eq(@gremium)
    end
    describe "without user" do 
      logout_user
      it_behaves_like "it is restricted"
    end 
    
  end

  describe "POST create" do
    subject(:action){post :create, {:gremium => FactoryGirl.attributes_for(:gremium),:format=>:html}}

    login_fet_user
    describe "with valid params" do

      it "has a 302 status code" do
        expect(action.status).to eq(302)
      end      
      it "creates a new Gremium" do
        expect{action}.to change(Gremium, :count).by(1)
      end
      
      it_behaves_like "it assigns persisted object"


      it "redirects to the created gremium" do
        expect(action).to redirect_to assigns(:gremium)
      end
    end

    describe "with invalid params" do
      has_invalid_params
   

      it "assigns a newly created but unsaved gremium as @gremium" do
        action
        assigns(:gremium).should be_a_new(Gremium)
        expect(assigns(:gremium)).not_to be_persisted
      end
      it "re-renders the 'new' template" do
        expect(action).to render_template("new")
      end
    end
    describe "without user" do 
      logout_user
      it_behaves_like "it is restricted"
    end 

  end

  describe "PUT update" do
    let(:action) { put :update, {:id => @gremium.to_param, :gremium => {"name"=>"neuerName"}} }
    
    create_gremium
    login_fet_user

    describe "with valid params" do
      it_behaves_like "it assigns object"

      it "updates the requested gremium" do
       expect { action }.to change{Gremium.find(@gremium.id).name}.to("neuerName")
      end
      it_behaves_like "it assigns persisted object"

      it "redirects to the gremium" do
        expect(action).to redirect_to(@gremium)
      end
    end

    describe "with invalid params" do
      has_invalid_params
      it_behaves_like "it assigns object"
      it "re-renders the 'edit' template" do
        expect(action).to render_template("edit")
      end
    end
    describe "without user" do 
      logout_user
      it_behaves_like "it is restricted"
    end 
  end

  describe "DELETE destroy" do
    login_fet_user
    create_gremium
    subject(:action) { delete :destroy, {:id => @gremium.to_param}}

    it "destroys the requested gremium" do
      expect {
       action
      }.to change(Gremium, :count).by(-1)
    end

    it "redirects to the gremien list" do
      action
      response.should redirect_to(gremien_url)
    end
    describe "without user" do 
      logout_user
      it_behaves_like "it is restricted"
    end 

  end

end

